/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */
package metier;

/**
 *
 * @author emile.lalorcey
 */
public class Joueur {
    private String nom;
    private int nbVie;
    private Position laPosition;
    private int nbDeplacement;
    private boolean aGagne;
    private boolean mort;
    
    // Constructeur
    
    public Joueur(){
    }
    public Joueur(String nom,int vie,Position pos){
        this.nom = nom;
        this.nbVie = vie;
        this.laPosition = pos;
    }
    
    // Guetteur
    public Position getLaPosition(){
        return this.laPosition;
    }
    
    public boolean isaGagne(){
        return this.aGagne;
    }
    
    public boolean isMort(){
        return this.mort;
    }
    
    public int getNbDeplacement(){
        return this.nbDeplacement;
    }
    
    public int getNbVie(){
        return this.nbVie;
    }
    
    public String getNom(){
        return this.nom;
    }
    
    // Setteur
    
    public void setPosition(Position pos){
        this.laPosition = pos;
    }
    
    public void setaGagne(boolean gagne){
        this.aGagne = gagne;
    }
    
    public void setNbDeplacement(int deplacement){
        this.nbDeplacement = deplacement;
    }
    
    public boolean mourir(){
        this.mort = true;
        return this.mort;
    }
    
// Methodes
    
    public void faireVarierVie (int varier){
        if((this.nbVie+varier)>0){
            this.nbVie += varier;
        }else{
            this.nbVie = 0;
            this.mourir();
        }           
    }
    
    public Position deplacer(char direction, int nbCol, int nbLignes){
        int y = this.getLaPosition().getPosY();
        int x = this.getLaPosition().getPosX();
        switch(direction){
            case 'n':
                if((y-1)>=0){
                    y--;
                }else{
                    System.out.println("Limite de map atteinte!! Demi-tour");
                }
                break;
            case 's':
                if((y+1)<= nbLignes-1){
                    y++;

                }else{
                    System.out.println("Limite de map atteinte!! Demi-tour");
                }
                break;
            case 'o':
                if((x-1)>=0){
                    x--;
                }else{
                    System.out.println("Limite de map atteinte!! Demi-tour");
                }    
                break;
            case 'e':
                if((x+1)<= nbCol-1){
                    x++;
                }else{
                    System.out.println("Limite de map atteinte!! Demi-tour");
                }
                break;
        }
        return new Position(x, y);
    }
    
    @Override
    public String toString(){
        String infos = "La classe est " + this.getClass()+"\nSon nom est "+this.getNom()+"\n"
                + "Son nombre de vie vaut "+this.getNbVie()+"\nSa position est  "+this.getLaPosition()+"\n"
                + "Il s'est dj deplacer "+this.getNbDeplacement()+"Il est mort :"+ this.isMort();
        return infos;
    }
    
    
    
    
    
    
    
    
    
}
